Contribution Agreement
======================

As a contributor, you represent that the code you submit is your original work or
that of your employer (in which case you represent you have the right to bind your
employer). By submitting code, you (and, if applicable, your employer) are
licensing the submitted code to LinkedIn and the open source community subject to
the BSD 2-Clause license.

General Contribution Tips
=========================

We welcome any contributions that make TonY more reliable, accurate, usable, or
extensible. It is generally preferred that new features and behaviors should be
configurable unless sufficient discussion is held to determine that there is no
situation in which the previous behavior is desirable. GitHub issues are the
appropriate forum for such discussions.

Responsible Disclosure of Security Vulnerabilities
==================================================

**Do not file an issue on Github for security issues.**  Please review
the [guidelines for disclosure][disclosure_guidelines].  Reports should
be encrypted using PGP ([public key][pubkey]) and sent to
[security@linkedin.com][disclosure_email] preferably with the title
"Vulnerability in Github LinkedIn/tony - &lt;short summary&gt;".

Tips for Getting Your Pull Request Accepted
===========================================

1. Make sure all new features are tested and the tests pass.
2. Bug fixes must include a test case demonstrating the error that it fixes.
3. Open an issue first and seek advice for your change before submitting
   a pull request. Large features which have never been discussed are
   unlikely to be accepted. **You have been warned.**

[disclosure_guidelines]: https://www.linkedin.com/help/linkedin/answer/62924
[pubkey]: https://gist.github.com/chriseppstein/3f45d3a8e6fb42f24cb7b3f77f21381e
[disclosure_email]: mailto:security@linkedin.com?subject=Vulnerability%20in%20Github%20LinkedIn/tony%20-%20%3Csummary%3E
